;;(autoload 'lpc-mode  "~/.xemacs/lpc-mode.el" t) 
 
;;(setq auto-mode-alist 
;;    (append '(("\\.c$" . lpc-mode)) auto-mode-alist)) ) 


(defconst my-c-style
  '((c-tab-always-indent        . t)
    (c-comment-only-line-offset . 4)
    (c-hanging-braces-alist     . ((substatement-open after)
                                   (brace-list-open)))
    (c-hanging-colons-alist     . ((member-init-intro before)
                                   (inher-intro)
                                   (case-label after)
                                   (label after)
                                   (access-label after)))
    (c-cleanup-list             . (scope-operator
                                   empty-defun-braces
                                   defun-close-semi))
    (c-offsets-alist            . ((arglist-close . c-lineup-arglist)
                                   (substatement-open . 0)
                                   (case-label        . 4)
                                   (block-open        . 0)
                                   (knr-argdecl-intro . -)))
    (c-echo-syntactic-information-p . t)
    )
  "My C Programming Style")


;; Customizations for all modes in CC Mode.
(defun my-ref-c-mode-common-hook ()
  ;; add my personal style and set it for the current buffer
  (c-add-style "PERSONAL" my-c-style t)
  ;; offset customizations not in my-c-style
  (c-set-offset 'member-init-intro '++)
  ;; other customizations
  (setq tab-width 4
        ;; this will make sure spaces are used instead of tabs
        indent-tabs-mode nil)
  ;; we like auto-newline and hungry-delete
  (c-toggle-auto-hungry-state 1)
  ;; keybindings for all supported languages.  We can put these in
  ;; c-mode-base-map because c-mode-map, c++-mode-map, objc-mode-map,
  ;; java-mode-map, idl-mode-map, and pike-mode-map inherit from it.
  (define-key c-mode-base-map "\C-m" 'newline-and-indent)
  )

(defun my-c-mode-common-hook ()
  ;; strictly my stuff
  (c-set-style "bsd")
  (setq c-basic-offset 4)
  (c-set-offset 'case-label '+)                   ;; indent case lables.
  (c-set-offset 'arglist-intro 'c-lineup-arglist-intro-after-paren)
  (c-set-offset 'arglist-close 'c-lineup-arglist) ;; autoindent multiline
  (setq tab-width 4
        ;; this will make sure spaces are used instead of tabs
        indent-tabs-mode nil)
  (define-key c-mode-base-map "\C-m" 'newline-and-indent)
	
  (setq info-lookup-highlight-overlay t)
  (local-set-key  "\C-f" 'info-lookup-symbol)

  (setq c-font-lock-keywords-3 
	 (append c-font-lock-keywords-3
		  (list (list (mapconcat 'identity 
								 (list "[][.~!+&*/%<>^?:;,\\{\\}\\(\\)-]"
									   "->\\*?"
									   "\\([<>+|&-]\\)\\1"
									   "[<>!=*/%+&|^-]?="
									   "<<=" ">>=")
								 "\\|")
		0 'font-lock-operator-face 'append)))
	 )
)

(add-hook 'c-mode-common-hook 'my-c-mode-common-hook)

(set-input-mode nil nil t)
(line-number-mode 1)

(put 'narrow-to-page 'disabled nil)
(put 'eval-expression 'disabled nil)

(setq auto-mode-alist (append (list (cons "\\.txt$"  'text-mode))
			      (list (cons "\\.perl$" 'perl-mode))
			      (list (cons "\\.ail$"  'ail-mode))
			      (list (cons "\\.uil$"  'ail-mode))
			      (list (cons "\\.ddl$"  'c++-mode))
			      (list (cons "akefile$" 'makefile-mode))
			      (list (cons "\\.def$"  'makefile-mode))
			      (list (cons "\\.mk$"   'makefile-mode))
			      (list (cons "\\.html$" 'html-mode))
			      (list (cons "\\.sc\\'" 'c++-mode))
			      (list (cons "\\.cpp$"  'c++-mode))
			      (list (cons "\\.cc$"   'c++-mode))
;;			      (list (cons "\\.c$"    'c++-mode))
			      (list (cons "\\.h$"    'c++-mode))
			      (list (cons "\\.py$"   'python-mode))
			      auto-mode-alist
			      ))

(setq font-lock-maximum-decoration t)
(require 'font-lock)

(setq font-lock-maximum-decoration t)

(setq scroll-step 4)
(setq transient-mark-mode nil)
(setq fill-column 75)
(setq inhibit-startup-message t)
(setq display-time-24hr-format t)

(setq scroll-in-place t)

(global-set-key [(button4)] 'scroll-down-command)
(global-set-key [(button5)] 'scroll-up-command)
	
(global-set-key [(shift up)] 'backward-paragraph)
(global-set-key [(shift down)] 'forward-paragraph)

;; 
;;  Highlight operators and some commonly used types.
;;

(custom-set-faces '(font-lock-operator-face ((t (:foreground "yellow"))) t))

(defun tkil-highlight-operators ()
  (setq c++-font-lock-keywords-3 
		(append c++-font-lock-keywords-3
				(list (list (mapconcat 'identity 
									   (list "[][.~!+&*/%<>^?:;,\\{\\}\\(\\)-]"
											 "->\\*?"
											 "\\([<>+|&-]\\)\\1"
											 "[<>!=*/%+&|^-]?="
											 "<<=" ">>=")
									   "\\|")
							0 'font-lock-operator-face 'append)))
		)
  (remove-hook 'c++-mode-hook 'tkil-highlight-operators))
(add-hook 'c++-mode-hook 'tkil-highlight-operators) 

(setq c++-font-lock-keywords-3
      (append c++-font-lock-keywords-3
              (list (cons "\\<\\(int8\\)\\>" 'font-lock-type-face)
					(cons "\\<\\(uint8\\)\\>" 'font-lock-type-face)
					(cons "\\<\\(int16\\)\\>" 'font-lock-type-face)
					(cons "\\<\\(uint16\\)\\>" 'font-lock-type-face)
					(cons "\\<\\(int32\\)\\>" 'font-lock-type-face)
					(cons "\\<\\(uint32\\)\\>" 'font-lock-type-face)	
					(cons "\\<\\(int64\\)\\>" 'font-lock-type-face)
					(cons "\\<\\(uint64\\)\\>" 'font-lock-type-face)
				)))

(make-local-variable 'font-lock-defaults)

(require 'backup-dir)
  (setq bkup-backup-directory-info
        '(("/home/greg/.*" "/~/.backups/" ok-create full-path prepend-name)
          ("^/[^/:]+:"     ".backups/") ; handle EFS files specially: don't 
          ("^/[^/:]+:"     "./")        ; search-upward... its very slow
          (t               ".backups/" full-path prepend-name search-upward)))

